---
title: WritableStream.WritableStream()
slug: Web/API/WritableStream/WritableStream
tags:
  - API
  - Constructor
  - Experimental
  - Reference
  - Streams
  - WritableStream
---
<div>{{draft}}{{SeeCompatTable}}{{APIRef("Streams")}}</div>

<p class="summary">The <strong><code>WritableStream()</code></strong> constructor creates a new {{domxref("WritableStream")}} object instance.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>writableStream</em> = new WritableStream(<em>underlyingSink</em>[, <em>queuingStrategy</em>]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>underlyingSink</dt>
 <dd>An object containing methods and properties that define how the constructed stream instance will behave. <code>underlyingSink</code> can contain the following:
 <dl>
  <dt>start(controller) {{optional_inline}}</dt>
  <dd>This is a method, called immediately when the object is constructed. The contents of this method are defined by the developer, and should aim to get access to the underlying sink. If this process is to be done asynchronously, it can return a promise to signal success or failure. The <code>controller</code> parameter passed to this method is a {{domxref("WritableStreamDefaultController")}}. This can be used by the developer to control the stream during set up.</dd>
  <dt>write(chunk, controller) {{optional_inline}}</dt>
  <dd>This method, also defined by the developer, will be called when a new chunk of data (specified in the <code>chunk</code> parameter) is ready to be written to the underlying sink. It can return a promise to signal success or failure of the write operation. The <code>controller</code> parameter passed to this method is a {{domxref("WritableStreamDefaultController")}} that can be used by the developer to control the stream as more chunks are submitted for writing. This method will be called only after previous writes have succeeded, and never after the stream is closed or aborted (see below).</dd>
  <dt>close(controller) {{optional_inline}}</dt>
  <dd>This method, also defined by the developer, will be called if the app signals that it has finished writing chunks to the stream. The contents should do whatever is necessary to finalize writes to the underlying sink, and release access to it. If this process is asynchronous, it can return a promise to signal success or failure. This method will be called only after all queued-up writes have succeeded. The <code>controller</code> parameter passed to this method is a {{domxref("WritableStreamDefaultController")}}, which can be used to control the stream at the end of writing.</dd>
  <dt>abort(reason) {{optional_inline}}</dt>
  <dd>This method, also defined by the developer, will be called if the app signals that it wishes to abruptly close the stream and put it in an errored state. It can clean up any held resources, much like <code>close()</code>, but <code>abort()</code> will be called even if writes are queued up — those chunks will be thrown away. If this process is asynchronous, it can return a promise to signal success or failure. The <code>reason</code> parameter contains a {{domxref("DOMString")}} describing why the stream was aborted.</dd>
 </dl>
 </dd>
 <dt>queuingStrategy {{optional_inline}}</dt>
 <dd>An object that optionally defines a queuing strategy for the stream. This takes two parameters:
 <dl>
  <dt>highWaterMark</dt>
  <dd>A non-negative integer — this defines the total number of chunks that can be contained in the internal queue before backpressure is applied.</dd>
  <dt>size(chunk)</dt>
  <dd>A method containing a parameter <code>chunk</code> — this indicates the size to use for each chunk, in bytes.</dd>
 </dl>

 <div class="note">
 <p><strong>Note</strong>: You could define your own custom <code>queuingStrategy</code>, or use an instance of {{domxref("ByteLengthQueuingStrategy")}} or {{domxref("CountQueuingStrategy")}} for this object value. If no <code>queuingStrategy</code> is supplied, the default used is the same as a <code>CountQueuingStrategy</code> with a high water mark of 1.</p>
 </div>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An instance of the {{domxref("WritableStream")}} object.</p>

<h2 id="Examples">Examples</h2>

<p>The following example illustrates several features of this interface.  It shows the creation of the <code>WritableStream</code> with a custom sink and an API-supplied queuing strategy. It then calls a function called <code>sendMessage()</code>, passing the newly created stream and a string. Inside this function it calls the stream's <code>getWriter()</code> method, which returns an instance of {{domxref("WritableStreamDefaultWriter")}}. A <code>forEach()</code> call is used to write each chunk of the string to the stream. Finally, <code>write()</code> and <code>close()</code> return promises that are processed to deal with success or failure of chunks and streams.</p>

<ul>
</ul>

<pre class="brush: js">const list = document.querySelector('ul');

function sendMessage(message, writableStream) {
  // defaultWriter is of type WritableStreamDefaultWriter
  const defaultWriter = writableStream.getWriter();
  const encoder = new TextEncoder();
  const encoded = encoder.encode(message, { stream: true });
  encoded.forEach((chunk) =&gt; {
    defaultWriter.ready
      .then(() =&gt; {
        return defaultWriter.write(chunk);
      })
      .then(() =&gt; {
        console.log("Chunk written to sink.");
      })
      .catch((err) =&gt; {
        console.log("Chunk error:", err);
      });
  });
  // Call ready again to ensure that all chunks are written
  //   before closing the writer.
  defaultWriter.ready
    .then(() =&gt; {
      defaultWriter.close();
    })
    .then(() =&gt; {
      console.log("All chunks written");
    })
    .catch((err) =&gt; {
      console.log("Stream error:", err);
    });
}

const decoder = new TextDecoder("utf-8");
const queuingStrategy = new CountQueuingStrategy({ highWaterMark: 1 });
let result = "";
const writableStream = new WritableStream({
  // Implement the sink
  write(chunk) {
    return new Promise((resolve, reject) =&gt; {
      var buffer = new ArrayBuffer(2);
      var view = new Uint16Array(buffer);
      view[0] = chunk;
      var decoded = decoder.decode(view, { stream: true });
      var listItem = document.createElement('li');
      listItem.textContent = "Chunk decoded: " + decoded;
      list.appendChild(listItem);
      result += decoded;
      resolve();
    });
  },
  close() {
    var listItem = document.createElement('li');
    listItem.textContent = "[MESSAGE RECEIVED] " + result;
    list.appendChild(listItem);
  },
  abort(err) {
    console.log("Sink error:", err);
  }
}, queuingStrategy);

sendMessage("Hello, world.", writableStream);</pre>

<p>You can find the full code in our <a href="https://mdn.github.io/dom-examples/streams/simple-writer/">Simple writer example</a>.</p>

<h3 id="Backpressure">Backpressure</h3>

<p>Because of how backpressure is supported in the API, its implementation in code may be less than obvious. To see how backpressure is implemented look for three things.</p>

<ul>
 <li>The <code>highWaterMark</code> property, which is set when creating the counting strategy (line 35), sets the maximum amount of data that the <code>WritableStream</code> instance will handle in a single <code>write()</code> operation. In this example, it's the maximum amount of data that can be sent to <code>defaultWriter.write()</code> (line 11).</li>
 <li>The <code>defaultWriter.ready</code> property returns a promise that resolves when the sink (the first property of the <code>WritableStream</code> constructor) is done writing data. The data source can wither write more data (line 11) or call <code>close()</code> (line 24). Calling <code>close()</code> too early can prevent data from being written. This is why the example calls <code>defaultWriter.ready</code> twice (lines 9 and 22). </li>
 <li>The {{jsxref("Promise")}} returned by the sink's <code>write()</code> method (line 40) tells the <code>WritableStream</code> and its writer when to resolve <code>defaultWriter.ready</code>.</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Streams","#ws-constructor","WritableStream()")}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.WritableStream.WritableStream")}}</p>
